#region Copyright Morrison Shwartz, Inc - Author: Jonah Stagner 
/////////////////////////////////////////////////////////////////////////
// Copyright Morrison Schwartz, Inc 2003-2004, All rights reserved     //
//---------------------------------------------------------------------//
//Author: Jonah L. Stagner                                             //
//---------------------------------------------------------------------//
// This product is protected by US Copyright laws and international    //
// treaties.  For more information, see the End User License Agreement //
// in the application installation folder.                             //
//---------------------------------------------------------------------//
// Visit us on the web at: http://www.ms-inc.net                       //
/////////////////////////////////////////////////////////////////////////
#endregion


using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using SharpTools;
using SharpTools.Settings;

namespace Add_Copyright_Notices
{

	/// <summary>
	/// Allows the user to edit and customize the text that is added by the 
	/// AddCopyrightNotices plugin
	/// </summary>
	public class HeaderProperties : PropertyPageBase
	{

		#region Housekeeping 

		private System.Windows.Forms.TextBox HeaderText;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public HeaderProperties()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.HeaderText = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// HeaderText
			// 
			this.HeaderText.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.HeaderText.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.HeaderText.Location = new System.Drawing.Point(5, 90);
			this.HeaderText.Multiline = true;
			this.HeaderText.Name = "HeaderText";
			this.HeaderText.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.HeaderText.Size = new System.Drawing.Size(365, 240);
			this.HeaderText.TabIndex = 0;
			this.HeaderText.Text = "";
			this.HeaderText.WordWrap = false;
			// 
			// label1
			// 
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 16F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(385, 28);
			this.label1.TabIndex = 1;
			this.label1.Text = "Add Copyright Plugin";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label2.Location = new System.Drawing.Point(5, 45);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(365, 30);
			this.label2.TabIndex = 2;
			this.label2.Text = "Enter the text that you would like added to each code file when the Add Copyright" +
				" Notice plugin is run";
			// 
			// HeaderProperties
			// 
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.HeaderText);
			this.Name = "HeaderProperties";
			this.Size = new System.Drawing.Size(385, 345);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region PropertyPageBase implementation 

		public override string ID { get { return "37227B7A-468F-4b31-8EA6-FD9B3ACA50C2"; } }
		public override string Section { get { return "Add Copyright Notice"; } }
		public override string Heading { get { return "Edit Copyright notice"; } }

		public override void LoadSettings( IProperties settings )
		{
			settings = (IProperties) Globals.Properties.GetProperty( "Add Copyright Notice", new Properties() );
			HeaderText.Text = (string) settings.GetProperty( "HeaderText", "" );
		}

		public override void SaveSettings( IProperties settings )
		{
			settings = (IProperties) Globals.Properties.GetProperty( "Add Copyright Notice", new Properties() );
			settings.SetProperty( "HeaderText", HeaderText.Text );
		}

		#endregion

	}

}
