using System;
using System.IO;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Threading;
using Timers = System.Timers;

using SharpTools;
using SharpTools.DOM;
using SharpTools.IDE;

using RSSReader.OPML;
using RSSReader.RSS;
using RSSReader.Controls;
using RSSReaderPlugin;

namespace RSSReader
{

	/// <summary>
	/// User interface for exploring and managing subscriptions
	/// </summary>
	public class SubscriptionExplorer : System.Windows.Forms.UserControl
	{

		#region 

		private System.Windows.Forms.Panel pnlTree;
		private RSSReader.Controls.JSTree tvwSubscriptions;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton tbNewCategory;
		private System.Windows.Forms.ToolBarButton tbNewSubscription;
		private System.Windows.Forms.ImageList imlTree;
		private System.Windows.Forms.ToolBarButton tbDelete;
		private System.Windows.Forms.ContextMenu mnuTree;
		private System.Windows.Forms.MenuItem mnuAddCategory;
		private System.Windows.Forms.MenuItem mnuAddSubscription;
		private System.Windows.Forms.MenuItem mnuDelete;
		private System.Windows.Forms.MenuItem mnuSeperator1;
		private System.Windows.Forms.ToolBarButton tbRefresh;
		private System.Windows.Forms.ToolBarButton tbImport;
		private System.Windows.Forms.ToolBarButton tbProperties;
		private System.Windows.Forms.MenuItem mnuProperties;
		private System.Windows.Forms.MenuItem mnuRefresh;
		private System.Windows.Forms.MenuItem mnuMarkAsRead;
		private System.Windows.Forms.MenuItem mnuRename;
		private System.Windows.Forms.ToolBarButton tbFindFeeds;
		private System.Windows.Forms.MenuItem mnuOpenInBrowser;
		private System.Windows.Forms.ToolBarButton tbSearch;
		private System.Windows.Forms.ToolBarButton tbSearchSyndic8;
		private System.ComponentModel.IContainer components;

		public SubscriptionExplorer()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.Load += new EventHandler(SubscriptionExplorer_Load);

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SubscriptionExplorer));
			this.pnlTree = new System.Windows.Forms.Panel();
			this.tvwSubscriptions = new RSSReader.Controls.JSTree();
			this.mnuTree = new System.Windows.Forms.ContextMenu();
			this.mnuAddCategory = new System.Windows.Forms.MenuItem();
			this.mnuAddSubscription = new System.Windows.Forms.MenuItem();
			this.mnuSeperator1 = new System.Windows.Forms.MenuItem();
			this.mnuRename = new System.Windows.Forms.MenuItem();
			this.mnuMarkAsRead = new System.Windows.Forms.MenuItem();
			this.mnuDelete = new System.Windows.Forms.MenuItem();
			this.mnuProperties = new System.Windows.Forms.MenuItem();
			this.mnuOpenInBrowser = new System.Windows.Forms.MenuItem();
			this.mnuRefresh = new System.Windows.Forms.MenuItem();
			this.imlTree = new System.Windows.Forms.ImageList(this.components);
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbNewCategory = new System.Windows.Forms.ToolBarButton();
			this.tbNewSubscription = new System.Windows.Forms.ToolBarButton();
			this.tbDelete = new System.Windows.Forms.ToolBarButton();
			this.tbProperties = new System.Windows.Forms.ToolBarButton();
			this.tbRefresh = new System.Windows.Forms.ToolBarButton();
			this.tbFindFeeds = new System.Windows.Forms.ToolBarButton();
			this.tbSearchSyndic8 = new System.Windows.Forms.ToolBarButton();
			this.tbSearch = new System.Windows.Forms.ToolBarButton();
			this.tbImport = new System.Windows.Forms.ToolBarButton();
			this.pnlTree.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnlTree
			// 
			this.pnlTree.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlTree.Controls.Add(this.tvwSubscriptions);
			this.pnlTree.Controls.Add(this.toolBar1);
			this.pnlTree.Location = new System.Drawing.Point(0, 0);
			this.pnlTree.Name = "pnlTree";
			this.pnlTree.Size = new System.Drawing.Size(240, 504);
			this.pnlTree.TabIndex = 1;
			// 
			// tvwSubscriptions
			// 
			this.tvwSubscriptions.AllowDrop = true;
			this.tvwSubscriptions.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tvwSubscriptions.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.tvwSubscriptions.ContextMenu = this.mnuTree;
			this.tvwSubscriptions.Enabled = false;
			this.tvwSubscriptions.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tvwSubscriptions.HideSelection = false;
			this.tvwSubscriptions.ImageList = this.imlTree;
			this.tvwSubscriptions.Indent = 20;
			this.tvwSubscriptions.Location = new System.Drawing.Point(0, 26);
			this.tvwSubscriptions.Name = "tvwSubscriptions";
			this.tvwSubscriptions.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
																						 new System.Windows.Forms.TreeNode("Loading subscriptions...", 14, 14)});
			this.tvwSubscriptions.ShowRootLines = false;
			this.tvwSubscriptions.Size = new System.Drawing.Size(240, 478);
			this.tvwSubscriptions.TabIndex = 1;
			this.tvwSubscriptions.MouseDown += new System.Windows.Forms.MouseEventHandler(this.tvwSubscriptions_MouseDown);
			this.tvwSubscriptions.AfterExpand += new System.Windows.Forms.TreeViewEventHandler(this.tvwSubscriptions_AfterExpand);
			this.tvwSubscriptions.AfterCollapse += new System.Windows.Forms.TreeViewEventHandler(this.tvwSubscriptions_AfterCollapse);
			this.tvwSubscriptions.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvwSubscriptions_AfterSelect);
			this.tvwSubscriptions.DoubleClick += new System.EventHandler(this.tvwSubscriptions_DoubleClick);
			this.tvwSubscriptions.MouseMove += new System.Windows.Forms.MouseEventHandler(this.tvwSubscriptions_MouseMove);
			this.tvwSubscriptions.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.tvwSubscriptions_ItemDrag);
			// 
			// mnuTree
			// 
			this.mnuTree.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuAddCategory,
																					this.mnuAddSubscription,
																					this.mnuSeperator1,
																					this.mnuRename,
																					this.mnuMarkAsRead,
																					this.mnuDelete,
																					this.mnuProperties,
																					this.mnuOpenInBrowser,
																					this.mnuRefresh});
			this.mnuTree.Popup += new System.EventHandler(this.mnuTree_Popup);
			// 
			// mnuAddCategory
			// 
			this.mnuAddCategory.Index = 0;
			this.mnuAddCategory.Text = "Add new &Category";
			this.mnuAddCategory.Click += new System.EventHandler(this.mnuAddCategory_Click);
			// 
			// mnuAddSubscription
			// 
			this.mnuAddSubscription.Index = 1;
			this.mnuAddSubscription.Text = "Add new Feed &Subscription";
			this.mnuAddSubscription.Click += new System.EventHandler(this.mnuAddSubscription_Click);
			// 
			// mnuSeperator1
			// 
			this.mnuSeperator1.Index = 2;
			this.mnuSeperator1.Text = "-";
			// 
			// mnuRename
			// 
			this.mnuRename.Index = 3;
			this.mnuRename.Text = "Re&name";
			this.mnuRename.Click += new System.EventHandler(this.mnuRename_Click);
			// 
			// mnuMarkAsRead
			// 
			this.mnuMarkAsRead.Index = 4;
			this.mnuMarkAsRead.Text = "&Mark all as Read";
			this.mnuMarkAsRead.Click += new System.EventHandler(this.mnuMarkAsRead_Click);
			// 
			// mnuDelete
			// 
			this.mnuDelete.Index = 5;
			this.mnuDelete.Text = "&Delete";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// mnuProperties
			// 
			this.mnuProperties.Index = 6;
			this.mnuProperties.Text = "&Properties";
			this.mnuProperties.Click += new System.EventHandler(this.mnuProperties_Click);
			// 
			// mnuOpenInBrowser
			// 
			this.mnuOpenInBrowser.Index = 7;
			this.mnuOpenInBrowser.Text = "Open in default &Browser";
			this.mnuOpenInBrowser.Click += new System.EventHandler(this.mnuOpenInBrowser_Click);
			// 
			// mnuRefresh
			// 
			this.mnuRefresh.Index = 8;
			this.mnuRefresh.Text = "&Refresh";
			this.mnuRefresh.Click += new System.EventHandler(this.mnuRefresh_Click);
			// 
			// imlTree
			// 
			this.imlTree.ImageSize = new System.Drawing.Size(16, 16);
			this.imlTree.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlTree.ImageStream")));
			this.imlTree.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// toolBar1
			// 
			this.toolBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.toolBar1.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbNewCategory,
																						this.tbNewSubscription,
																						this.tbDelete,
																						this.tbProperties,
																						this.tbRefresh,
																						this.tbFindFeeds,
																						this.tbSearchSyndic8,
																						this.tbSearch,
																						this.tbImport});
			this.toolBar1.ButtonSize = new System.Drawing.Size(16, 16);
			this.toolBar1.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imlTree;
			this.toolBar1.Location = new System.Drawing.Point(0, 0);
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(240, 29);
			this.toolBar1.TabIndex = 3;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbNewCategory
			// 
			this.tbNewCategory.ImageIndex = 10;
			this.tbNewCategory.ToolTipText = "Add new category";
			// 
			// tbNewSubscription
			// 
			this.tbNewSubscription.ImageIndex = 2;
			this.tbNewSubscription.ToolTipText = "Add a new subscription";
			// 
			// tbDelete
			// 
			this.tbDelete.ImageIndex = 8;
			this.tbDelete.ToolTipText = "Delete";
			// 
			// tbProperties
			// 
			this.tbProperties.ImageIndex = 18;
			this.tbProperties.ToolTipText = "Feed Properties";
			// 
			// tbRefresh
			// 
			this.tbRefresh.ImageIndex = 14;
			this.tbRefresh.ToolTipText = "Refresh the selected node and all nodes below it";
			// 
			// tbFindFeeds
			// 
			this.tbFindFeeds.ImageIndex = 19;
			this.tbFindFeeds.ToolTipText = "Find all RSS feeds on a web page";
			// 
			// tbSearchSyndic8
			// 
			this.tbSearchSyndic8.ImageIndex = 24;
			this.tbSearchSyndic8.ToolTipText = "Find feeds by keyword";
			// 
			// tbSearch
			// 
			this.tbSearch.ImageIndex = 23;
			this.tbSearch.ToolTipText = "Search all feeds for key words";
			// 
			// tbImport
			// 
			this.tbImport.ImageIndex = 17;
			this.tbImport.ToolTipText = "Import Subscriptions from an OPML file";
			// 
			// SubscriptionExplorer
			// 
			this.BackColor = System.Drawing.SystemColors.Control;
			this.Controls.Add(this.pnlTree);
			this.Name = "SubscriptionExplorer";
			this.Size = new System.Drawing.Size(240, 504);
			this.pnlTree.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		#region Events 

		public delegate void NodeDoubleClickHandler( object sender, OPMLNode node );
		public delegate void NodeSelectHandler( object sender, OPMLNode node );
		public delegate void NodeFeedRefreshedHandler( object sender, OPMLItemNode node );
		public delegate void SearchCompletedHandler( object sender, FeedSearchResults results );

		public event NodeDoubleClickHandler		NodeDoubleClick;
		public event NodeSelectHandler			NodeSelect;
		public event NodeFeedRefreshedHandler	NodeFeedRefreshed;
		public event SearchCompletedHandler		SearchComplete;

		#endregion 

		#region Constants 

		public static Font NodeDefaultFont = TreeView.DefaultFont;
		public static Font NodeBoldFont = new Font( NodeDefaultFont.FontFamily, NodeDefaultFont.SizeInPoints, FontStyle.Bold );

		private const int FOLDER_CLOSED = 3;
		private const int FOLDER_OPEN = 4;
		private const int FOLDER_UNREAD = 5;

		#endregion 

		private Timers.Timer	refreshTimer;
		private string			subscriptionFilePath;
		private OPMLFile		subscriptions;
		private int				totalSubscriptionCount = 0;
		private int				currentSubscriptionIndex = 0;

		public string SubscriptionFile
		{
			
			get { return subscriptionFilePath; }
			
			set 
			{ 
				 
				subscriptionFilePath = value; 
				subscriptions = new OPMLFile( subscriptionFilePath );
				if( tvwSubscriptions.Nodes.Count == 0 )
					RefreshTree();

			}

		}

		public void Stop()
		{

			lock( this )
			{

				if( refreshTimer != null )
				{
					refreshTimer.Stop();
					refreshTimer.Enabled = false;
					refreshTimer = null;
					Application.DoEvents();
				}

			}

		}

		private void PopulateFeedsNode()
		{

			TreeNode root = new MyFeedsNode();
			root.Text = "My Feeds";
			root.ImageIndex = 12;
			root.SelectedImageIndex = 12;
			tvwSubscriptions.Nodes.Add( root );

			totalSubscriptionCount = subscriptions.GetAllSubscriptions().Count;
			currentSubscriptionIndex = 0;

			foreach( OPMLNode outline in subscriptions.Nodes )
			{

				if( outline.Title != "RSSReader: FollowUp" )
					AddSubscriptionNode( root, outline );

			}

		}

		public void RefreshTree()
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;
				tvwSubscriptions.Enabled = true;

				tvwSubscriptions.BeginUpdate();

				PersistedTreeState state = new PersistedTreeState( tvwSubscriptions );

				tvwSubscriptions.Nodes.Clear();

				if( subscriptions == null )
					return;

				PopulateFeedsNode();

				// Expand all root-level nodes
				foreach( TreeNode node in tvwSubscriptions.Nodes )
					node.Expand();

				state.Restore();

			}
			finally
			{
				tvwSubscriptions.EndUpdate();
				this.Cursor = Cursors.Default;
				ShowStatus( "Done" );
			}

		}

		public OPMLTreeNode SelectedNode
		{

			get
			{

				TreeNode selected = tvwSubscriptions.SelectedNode;
				if( !(selected is OPMLTreeNode) )
					return null;
				else
					return (OPMLTreeNode) selected;

			}

			set
			{
				tvwSubscriptions.SelectedNode = value;
			}

		}

		private void SetTreeNodeImageIndex( TreeNode node )
		{

			if( node is CategoryTreeNode )
			{

				if( node.IsExpanded )
				{
					node.ImageIndex = FOLDER_OPEN;
					node.SelectedImageIndex = FOLDER_OPEN;
				}
				else
				{
					node.ImageIndex = FOLDER_CLOSED;
					node.SelectedImageIndex = FOLDER_CLOSED;
				}

				return;

			}

			if( node is SubscriptionTreeNode )
			{

				if( ((SubscriptionTreeNode) node).HasFollowUpItems )
				{
					node.ImageIndex = 22;
					node.SelectedImageIndex = 22;
				}
				else
				{
					node.ImageIndex = 2;
					node.SelectedImageIndex = 2;
				}

			}

		}

		private TreeNode AddSubscriptionNode( TreeNode Parent, OPMLNode Subscription )
		{

			currentSubscriptionIndex += 1;
			ShowStatus( "Loading subscription tree: " + Subscription.Title, currentSubscriptionIndex, totalSubscriptionCount );
			TreeNode node = OPMLTreeNode.Create( Subscription );

			if( Parent != null )
				Parent.Nodes.Add( node );
			else
				tvwSubscriptions.Nodes.Add( node );

			if( node is CategoryTreeNode )
			{

				foreach( OPMLNode child in ((OPMLCategoryNode) Subscription).Nodes )
					AddSubscriptionNode( node, child );

			}

			SetTreeNodeImageIndex( node );

			return node;

		}

		public TreeNode FindNodeForFeed( string url )
		{
			
			ArrayList nodes = TreeViewHelper.GetAllNodes( tvwSubscriptions );
			foreach( TreeNode node in nodes )
			{

				if( node is SubscriptionTreeNode )
				{

					OPMLItemNode item = ((SubscriptionTreeNode) node).Subscription;
					if( item.XmlUrl.ToLower() == url.ToLower() )
						return node;

				}

			}

			return null;

		}

		private void tvwSubscriptions_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;
		
				tbDelete.Enabled = ( e.Node is OPMLTreeNode );
				tbNewCategory.Enabled = (e.Node.Tag == null) || (e.Node is CategoryTreeNode);
				tbNewSubscription.Enabled = tbNewCategory.Enabled;
				tbProperties.Enabled = ( e.Node is SubscriptionTreeNode );

				if( NodeSelect != null )
					NodeSelect( this, (OPMLNode) tvwSubscriptions.SelectedNode.Tag );

			}
			finally
			{
				this.Cursor = Cursors.Default;
			}

		}

		private void tvwSubscriptions_DoubleClick(object sender, System.EventArgs e)
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;

				if( tvwSubscriptions.SelectedNode == null )
					return;

				if( NodeDoubleClick != null )
					NodeDoubleClick( this, (OPMLNode) tvwSubscriptions.SelectedNode.Tag );

			}
			finally
			{
				this.Cursor = Cursors.Default;
			}
		
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
		
			if( e.Button == tbNewCategory )
				AddNewCategory();
			else if( e.Button == tbNewSubscription )
				AddNewSubscription();
			else if( e.Button == tbDelete )
				DeleteNode();
			else if( e.Button == tbRefresh )
				RefreshCurrentNode();
			else if( e.Button == tbImport )
				ImportSubscriptions();
			else if( e.Button == tbProperties )
				EditProperties();
			else if( e.Button == tbFindFeeds )
				SearchWebForFeeds();
			else if( e.Button == tbSearch )
				SearchLocalFeeds();
			else if( e.Button == tbSearchSyndic8 )
				SearchSyndic8();

		}

		private void SearchSyndic8()
		{

			ArrayList result = RSSReaderPlugin.Forms.Syndic8Search.Search();
			if( result == null )
				return;

			foreach( RSSFeed feed in result )
			{

				OPMLItemNode newNode = new OPMLItemNode();
				newNode.XmlUrl = feed.XmlUrl;
				newNode.HtmlUrl = feed.HtmlUrl;
				newNode.Title = feed.Title;
				newNode.Description = feed.Description;

				FeedManager.SaveFeed( feed );

				subscriptions.Nodes.Add( newNode );

			}

			this.subscriptions.SaveToFile( this.subscriptionFilePath );

			RefreshTree();

		}

		private void SearchLocalFeeds()
		{

			SearchTerms terms = RSSReaderPlugin.Forms.SearchLocalFeeds.GetSearchTerms();
			if( terms == null )
				return;

			Globals.OutputWindow.Clear();
			Globals.OutputWindow.Activate();

			ArrayList results = new ArrayList();
			ArrayList nodes = subscriptions.GetAllSubscriptions();

			SearchLocalFeeds( results, terms, nodes );

			results.Sort();

			if( this.SearchComplete != null )
				this.SearchComplete( this, new FeedSearchResults( terms.Keywords, results ) );

		}

		private void SearchLocalFeeds( ArrayList Results, SearchTerms Terms, ArrayList Nodes )
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;

				int totalNodes = Nodes.Count;
				int currentNode = 0;

				foreach( OPMLNode node in Nodes )
				{

					currentNode += 1;

					Plugin.VSIDE.StatusBar.Progress( true, "Searching for " + Terms.Keywords, currentNode, totalNodes );

					Application.DoEvents();

					RSSFeed feed = FeedManager.GetCachedFeed( ((OPMLItemNode) node).XmlUrl );
					if( feed == null )
						continue;

					foreach( RSSItem item in feed.Items )
					{
					
						int titleRank = Terms.GetRank( item.Title );
						int subjectRank = Terms.GetRank( item.Subject );
						int descRank = Terms.GetRank( item.Description );
						int rank = titleRank + subjectRank + descRank;
						if( rank > 0 )
							Results.Add( new FeedSearchResult( rank, item ) );

					}

				}

			}
			catch( Exception err )
			{
				System.Diagnostics.Debug.WriteLine( err.ToString() );
			}
			finally
			{
				this.Cursor = Cursors.Default;
				Plugin.VSIDE.StatusBar.Progress( false, "Done", 0, 0 );
			}

		}

		private void SearchWebForFeeds()
		{

			ArrayList result = RSSReaderPlugin.Forms.SearchForFeeds.Search();
			if( result == null )
				return;

			try
			{

				this.Cursor = Cursors.WaitCursor;

				foreach( RSSFeed feed in result )
				{

					ShowStatus( "Adding subscription to feed: " + feed.Title );

					OPMLItemNode newNode = new OPMLItemNode();
					newNode.XmlUrl = feed.XmlUrl;
					newNode.HtmlUrl = feed.HtmlUrl;
					newNode.Title = feed.Title;
					newNode.Description = feed.Description;

					FeedManager.SaveFeed( feed );

					subscriptions.Nodes.Add( newNode );

				}

				this.subscriptions.SaveToFile( this.subscriptionFilePath );

				RefreshTree();

			}
			finally
			{
				this.Cursor = Cursors.Default;
			}

		}

		private void EditProperties()
		{

			if( !(tvwSubscriptions.ContextNode is SubscriptionTreeNode) )
				return;

			if( DialogResult.OK != FeedProperties.EditFeed( ((SubscriptionTreeNode) tvwSubscriptions.ContextNode).Subscription ) )
				return;

			subscriptions.SaveToFile( this.subscriptionFilePath );
			this.RefreshTree();

		}

		private void ImportSubscriptions()
		{

			OPMLFile import = ImportOPML.ImportOPMLFile( subscriptions, "" );
			if( import == null )
				return;

			foreach( OPMLNode importNode in import.Nodes )
			{

				if( importNode is OPMLItemNode )
				{
					OPMLItemNode feed = (OPMLItemNode) importNode;
					FeedManager.RetrieveFeedAsync( feed.XmlUrl, feed, new FeedManager.RetrieveFeedAsyncCallback( this.FeedRetrievedCallback ) );
				}

				subscriptions.Nodes.Add( importNode );

			}

			subscriptions.SaveToFile( this.subscriptionFilePath );

			RefreshTree();

		}

		private void RefreshCurrentNode()
		{

			try
			{

				this.Cursor = Cursors.WaitCursor;

				TreeNode selected = tvwSubscriptions.SelectedNode;
				if( selected == null )
					return;

				RefreshNodeFeed( selected );

			}
			finally
			{
				this.Cursor = Cursors.Default;
			}

		}

		private void RefreshNodeFeed( TreeNode node )
		{

			if( node is SubscriptionTreeNode )
			{

				string url = ((SubscriptionTreeNode) node).Subscription.XmlUrl;
				ShowStatus( "Refreshing RSS feed: " + node.Text );

				FeedManager.RetrieveFeedAsync( 
					url, 
					node, 
					new FeedManager.RetrieveFeedAsyncCallback( this.OnFeedRefreshed ) 
					);

				RSSFeed cachedFeed = FeedManager.GetCachedFeed( url );
				if( cachedFeed != null )
					RefreshFeedComments( cachedFeed );

			}
			else
			{

				foreach( TreeNode child in node.Nodes )
					RefreshNodeFeed( child );

			}

		}

		private void AddNewCategory()
		{

			string categoryName = NewCategory.GetCategoryName( this );
			if( categoryName == "" )
				return;

			OPMLCategoryNode category = new OPMLCategoryNode();
			category.Title = categoryName;
			category.Description = "";

			TreeNode newNode = null;

			bool addToRoot = (tvwSubscriptions.SelectedNode == null) ||
				!(tvwSubscriptions.SelectedNode is CategoryTreeNode);

			TreeNode parentNode;
			if( addToRoot )
				parentNode = tvwSubscriptions.Nodes[0];
			else
				parentNode = tvwSubscriptions.SelectedNode;

			foreach( TreeNode duplicateCheck in parentNode.Nodes )
			{

				if( duplicateCheck is CategoryTreeNode )
					if( ((OPMLCategoryNode) duplicateCheck.Tag).Title == categoryName )
					{
						MessageBox.Show( "You already have a Category at the current tree level with the same name", "RSS Reader" );
						return;
					}

			}

			if( addToRoot )
			{
				subscriptions.Nodes.Add( category );
				subscriptions.Nodes.Sort();
				newNode = AddSubscriptionNode( tvwSubscriptions.Nodes[0], category );
			}
			else
			{

				OPMLCategoryNode parentCategory = (OPMLCategoryNode) tvwSubscriptions.SelectedNode.Tag;
				parentCategory.Nodes.Add( category );
				parentCategory.Nodes.Sort();

				newNode = AddSubscriptionNode( tvwSubscriptions.SelectedNode, category );

			}

			RefreshTree();

			subscriptions.SaveToFile( this.subscriptionFilePath );

		}

		private void AddNewSubscription()
		{

			string feedUrl = NewSubscription.GetFeedUrl( this );
			if( feedUrl == "" )
				return;

			TreeNode duplicate = FindNodeForFeed( feedUrl );
			if( duplicate != null )
			{
				MessageBox.Show( "You are already subscribed to this feed.", "RSSReader" );
				tvwSubscriptions.SelectedNode = duplicate;
				duplicate.EnsureVisible();
				return;
			}

			bool addToRoot = (tvwSubscriptions.SelectedNode == null) ||
				!(tvwSubscriptions.SelectedNode is CategoryTreeNode);

			OPMLNodeCollection nodes = subscriptions.Nodes;
			if( !addToRoot )
				nodes = ((OPMLCategoryNode) tvwSubscriptions.SelectedNode.Tag).Nodes;

			ShowStatus( "Retrieving RSS Feed: " + feedUrl );
			RSS.RSSFeed feed = FeedManager.RetrieveFeed( feedUrl );
			if( feed == null )
				return;

			OPMLItemNode itemNode = new OPMLItemNode();
			itemNode.Title = feed.Title;
			itemNode.Description = feed.Description;
			itemNode.XmlUrl = feedUrl;
			itemNode.HtmlUrl = feed.HtmlUrl;

			nodes.Add( itemNode );
			nodes.Sort();

			RefreshTree();
			
			subscriptions.SaveToFile( subscriptionFilePath );

		}

		private void DeleteNode()
		{

			TreeNode selected = tvwSubscriptions.SelectedNode;

			if( selected == null || selected.Tag == null )
				return;

			OPMLNode opmlNode = (OPMLNode) selected.Tag;

			if( DialogResult.Yes != MessageBox.Show( "Are you sure you wish to delete \"" + opmlNode.Title + "\"?", "RSS Reader", MessageBoxButtons.YesNo ) )
				return;

			opmlNode.Delete( true );
			subscriptions.SaveToFile( subscriptionFilePath );
			selected.Remove();

		}

		private void tvwSubscriptions_AfterCollapse(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{

			if( e.Node is CategoryTreeNode )
			{
				SetTreeNodeImageIndex( e.Node );
			}
		
		}

		private void tvwSubscriptions_AfterExpand(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
		
			if( e.Node is CategoryTreeNode )
			{
				SetTreeNodeImageIndex( e.Node );
			}
		
		}

		private void mnuAddCategory_Click(object sender, System.EventArgs e)
		{
			AddNewCategory();
		}

		private void mnuAddSubscription_Click(object sender, System.EventArgs e)
		{
			AddNewSubscription();
		}

		private void mnuDelete_Click(object sender, System.EventArgs e)
		{
			DeleteNode();
		}

		private void mnuTree_Popup(object sender, System.EventArgs e)
		{

			if( tvwSubscriptions.ContextNode == null )
			{
				
				foreach( MenuItem item in mnuTree.MenuItems )
					item.Visible = false;

				return;

			}

			bool isNodeSelected = (tvwSubscriptions.ContextNode != null);

			mnuAddCategory.Visible = tbNewCategory.Enabled;
			mnuAddSubscription.Visible = tbNewSubscription.Enabled;
			mnuDelete.Visible = tbDelete.Enabled;
			mnuMarkAsRead.Visible = mnuRefresh.Visible;
			mnuRefresh.Visible = tbRefresh.Enabled;
			mnuProperties.Visible = (tvwSubscriptions.ContextNode is SubscriptionTreeNode);
			mnuOpenInBrowser.Visible = (tvwSubscriptions.ContextNode is SubscriptionTreeNode);
			mnuRename.Visible = (tvwSubscriptions.ContextNode is OPMLTreeNode);

			mnuSeperator1.Visible = (mnuAddCategory.Visible && mnuDelete.Visible) ||
				(mnuAddSubscription.Visible && mnuDelete.Visible);

		}

		private void tvwSubscriptions_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{

			if( e.Item is OPMLTreeNode )
				tvwSubscriptions.DoDragDrop( e.Item, DragDropEffects.Move );
				
		}

		private void tvwSubscriptions_MouseMove(object sender, MouseEventArgs e)
		{

		}

		private void tvwSubscriptions_MouseDown(object sender, MouseEventArgs e)
		{

			if( tvwSubscriptions.ContextNode != null )
				tvwSubscriptions.SelectedNode = tvwSubscriptions.ContextNode;
			else
				tvwSubscriptions.SelectedNode = null;

		}

		private void SubscriptionExplorer_Load(object sender, EventArgs e)
		{

			// Determine the bold and non-bold fonts that will be used by
			// the custom-draw TreeNode objects.
			NodeDefaultFont = tvwSubscriptions.Font;
			NodeBoldFont = new Font( 
				NodeDefaultFont.FontFamily, 
				NodeDefaultFont.SizeInPoints, 
				FontStyle.Bold 
				);

			// To fix the NodeFont issue, where nodes in Bold font are clipped, we
			// set the entire tree's Font property to the bold font.  Since each node
			// in the tree will be custom-draw anyways, all this does is tell the 
			// overly-bossy TreeView to calculate node rects based on a bold font.
 			// Stooopid workaround, but it's a bug in the MS treeview, so whatcha gonna do?
			tvwSubscriptions.Font = NodeBoldFont;

			tvwSubscriptions.NodeStartDrag += new RSSReader.Controls.JSTree.NodeStartDragEventHandler(tvwSubscriptions_NodeStartDrag);
			tvwSubscriptions.NodeDragOver += new RSSReader.Controls.JSTree.NodeDragOverEventHandler(tvwSubscriptions_NodeDragOver);
			tvwSubscriptions.NodeDragDrop += new RSSReader.Controls.JSTree.NodeDragDropEventHandler(tvwSubscriptions_NodeDragDrop);
			tvwSubscriptions.AfterLabelEdit += new NodeLabelEditEventHandler(tvwSubscriptions_AfterLabelEdit);

			refreshTimer = new Timers.Timer( TimeSpan.FromMinutes( 5 ).TotalMilliseconds );
			refreshTimer.Elapsed += new System.Timers.ElapsedEventHandler(refreshTimer_Elapsed);
			refreshTimer.Enabled = true;
			refreshTimer.Start();


		}

		public void UpdateFeedNode( RSSFeed feed )
		{

			TreeNode node = FindNodeForFeed( feed.XmlUrl );
			if( node is SubscriptionTreeNode )
				((SubscriptionTreeNode) node).RefreshNode( feed );

			SetTreeNodeImageIndex( node );
		
		}

		private void FeedRetrievedCallback( RSSFeed feed, object tag )
		{
			
			ShowStatus( "RSS feed retrieved: " + feed.Title );
			if( tag is OPMLItemNode )
				FeedManager.SaveFeed( feed );

			UpdateFeedNode( feed );

		}

		private void refreshTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
		{

			try
			{

				// We do not want to be creating network traffic while
				// the user is running their application in debug mode.
				if( SharpTools.IDE.Debugger.GetInstance().CurrentMode != SharpTools.IDE.DebuggerMode.Design )
					return;

				if( this.IsDisposed || !this.Visible )
				{
					refreshTimer.Stop();
					refreshTimer = null;
					return;
				}

				int feedsRefreshing = 0;

				ArrayList nodes = TreeViewHelper.GetAllNodes( tvwSubscriptions );
				foreach( TreeNode node in nodes )
				{

					Thread.Sleep( 5 );
					if( this.IsDisposed || !this.Visible )
						return;

					if( !(node is SubscriptionTreeNode) )
						continue;

					feedsRefreshing += 1;
					if( feedsRefreshing >= 10 )
						break;

					OPMLItemNode item = (OPMLItemNode) node.Tag;
					RSSFeed nodeFeed = FeedManager.GetCachedFeed( item.XmlUrl );
					if( nodeFeed.LastRefresh.Add( nodeFeed.RefreshRate ) < DateTime.Now )
					{
						ShowStatus( "Checking RSS Feed for updates: " + nodeFeed.Title );
						FeedManager.RetrieveFeedAsync( nodeFeed.XmlUrl, null, new FeedManager.RetrieveFeedAsyncCallback( OnFeedRefreshed ) );
					}

				}

			}
			catch( Exception err ) 
			{
				System.Diagnostics.Debug.WriteLine( err.ToString() );
			}

		}

		private void ShowStatus( string Text )
		{
			Plugin.VSIDE.StatusBar.Text = Text;
		}

		private void ShowStatus( string Text, int CurrentProgress, int MaxProgress )
		{
			Plugin.VSIDE.StatusBar.Progress( CurrentProgress < MaxProgress, Text, CurrentProgress, MaxProgress );
		}

		private void RefreshFeedComments( RSSFeed feed )
		{

			int totalItems = feed.GetItemCount();
			int commentNumber = 0;
			foreach( RSSItem feedItem in feed.Items )
			{

				ShowStatus( "Refreshing comments for " + feed.Title + " > " + feedItem.Title, ++commentNumber, totalItems );

				string commentUrl = feedItem.CommentFeedUrl;
				if( commentUrl == "" )
					continue;

				RSSFeed newCommentFeed = FeedManager.RetrieveFeed( commentUrl );
				if( newCommentFeed == null )
					continue;

				feedItem.Comments.Merge( newCommentFeed );
				feedItem.Comments.MaxItemAge = feed.MaxItemAge;
				FeedManager.SaveFeed( feedItem.Comments );

			}

			Plugin.VSIDE.StatusBar.Progress( false, "Done", 0, 0 );

		}

		private void OnFeedRefreshed( RSSFeed feed, object tag )
		{

			ShowStatus( "Refreshed RSS Feed: " + feed.Title );

			RSSFeed cachedFeed = FeedManager.GetCachedFeed( feed.XmlUrl );
			cachedFeed.Merge( feed );
			FeedManager.SaveFeed( cachedFeed );

			UpdateFeedNode( cachedFeed );

			if( NodeFeedRefreshed != null )
			{

				TreeNode feedNode = FindNodeForFeed( feed.XmlUrl );
				if( feedNode is SubscriptionTreeNode )
					NodeFeedRefreshed( this, ((SubscriptionTreeNode) feedNode).Subscription );

			}

		}

		private void mnuProperties_Click(object sender, System.EventArgs e)
		{
			EditProperties();
		}

		private void mnuRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshCurrentNode();
		}

		private void mnuMarkAsRead_Click(object sender, System.EventArgs e)
		{

			MarkAsRead( tvwSubscriptions.ContextNode );

		}

		private void MarkAsRead( TreeNode node )
		{

			if( node is SubscriptionTreeNode && ((SubscriptionTreeNode) node).UnreadMessageCount > 0 )
			{

				RSSFeed feed = FeedManager.GetCachedFeed( ((SubscriptionTreeNode) node).Subscription.XmlUrl );
				foreach( RSSItem item in feed.Items )
				{
					item.MarkedAsRead = true;
				}

				FeedManager.SaveFeed( feed );
				((SubscriptionTreeNode) node).RefreshNode( feed );

				if( this.NodeFeedRefreshed != null )
					this.NodeFeedRefreshed( feed, ((SubscriptionTreeNode) node).Subscription );

			}

			foreach( TreeNode child in node.Nodes )
				MarkAsRead( child );

		}

		private TreeNode GetBranchParent( TreeNode node )
		{

			while( node != null && node.Parent != null )
				node = node.Parent;

			return node;

		}

		private void tvwSubscriptions_NodeStartDrag(object sender, NodeStartDragEventArgs e)
		{

			if( !(e.Node is OPMLTreeNode) )
				e.Cancel = true;

			if( !(GetBranchParent( e.Node ) is MyFeedsNode) )
				e.Cancel = true;

		}

		private void tvwSubscriptions_NodeDragOver(object sender, NodeDragOverEventArgs e)
		{

			if( !(GetBranchParent( e.TargetNode ) is MyFeedsNode) )
			{
				e.Effect = DragDropEffects.None;
			}
			else
			{

				if( e.TargetNode is CategoryTreeNode || e.TargetNode == tvwSubscriptions.Nodes[0] )
					e.Effect = DragDropEffects.Move;
				else
					e.Effect = DragDropEffects.None;

			}

		}

		private void tvwSubscriptions_NodeDragDrop(object sender, NodeDragDropEventArgs e)
		{

			OPMLTreeNode node = (OPMLTreeNode) e.DragNode;
			OPMLNode data = (OPMLNode) node.Tag;
			data.Delete();

			if( e.TargetNode is CategoryTreeNode )
				((CategoryTreeNode) e.TargetNode).Category.Nodes.Add( data );
			else
				subscriptions.Nodes.Add( data );

			subscriptions.SaveToFile( this.subscriptionFilePath );
			RefreshTree();

		}

		private void tvwSubscriptions_AfterLabelEdit(object sender, NodeLabelEditEventArgs e)
		{

			// Restore the default LabelEdit setting
			tvwSubscriptions.LabelEdit = false;

			// If the user cancelled or has not changed the text, just exit
			// without further action.  The TreeView has taken care of 
			// redrawing the node, so we don't have to do anything even for
			// nodes which display an "Unread Messages" summary.
			if( e.Label == null || e.Label.Trim() == e.Node.Text.Trim() )
				return;

			// Rename the corresponding OPML file element
			if( e.Node is CategoryTreeNode )
				((CategoryTreeNode) e.Node).Category.Title = e.Label;
			else if( e.Node is SubscriptionTreeNode )
				((SubscriptionTreeNode) e.Node).Subscription.Title = e.Label;

			// By changing the node text and setting it to be selected, when
			// we do the RefreshTree() call, the selection will be restored 
			// to the renamed node.  This works because RefreshTree() saves
			// the current tree state, which works on node paths, which in 
			// turn relies on node text.
			e.Node.Text = e.Label.Trim();
			tvwSubscriptions.SelectedNode = e.Node;

			// Save the changes and reload the tree.  This has the nice side 
			// effect of re-sorting the tree, so that when the process is 
			// complete, the SelectedNode is the newly-renamed node, in it's 
			// new home in the tree ;)
			subscriptions.SaveToFile( this.subscriptionFilePath );
			RefreshTree();

		}

		private void mnuRename_Click(object sender, System.EventArgs e)
		{

			// Remove any "Unread Messages" count that may be visible
			TreeNode node = tvwSubscriptions.ContextNode;
			if( node is CategoryTreeNode )
				node.Text = ((CategoryTreeNode) node).Category.Title;
			else if( node is SubscriptionTreeNode )
				node.Text = ((SubscriptionTreeNode) node).Subscription.Title;

			tvwSubscriptions.LabelEdit = true;
			node.BeginEdit();
			tvwSubscriptions.Refresh();

		}

		private void mnuOpenInBrowser_Click(object sender, System.EventArgs e)
		{
		
			SubscriptionTreeNode node = (SubscriptionTreeNode) tvwSubscriptions.ContextNode;
			if( node != null )
			{

				string url = node.Subscription.HtmlUrl;
				if( url == "" )
				{
					
					url = node.Subscription.XmlUrl;
					int pos = url.LastIndexOf( "/" );
					if( pos != -1 )
						url = url.Substring( 0, pos );

					node.Subscription.HtmlUrl = url;
					this.subscriptions.SaveToFile( this.subscriptionFilePath );

				}

				System.Diagnostics.Process.Start( url );

			}

		}

	}

}
