using System;
using System.Collections;
using System.Collections.Specialized;

namespace RSSReader.HTTP
{

	/// <summary>
	/// Adapter for System.Collections.Specialized.StringDictionary, makes
	/// the string dictionary case-insensitive
	/// </summary>
	public class CaseInsensitiveStringDictionary : StringDictionary
	{

		public override void Add(string key, string value)
		{
			base.Add( key.ToLower(), value );
		}

		public override bool ContainsKey(string key)
		{
			return base.ContainsKey( key.ToLower() );
		}

		public override string this[string key]
		{
			get { return base[ key.ToLower() ]; }
			set { base[ key.ToLower() ] = value; }
		}

	}

}
