<xsl:stylesheet version='1.0' 
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'
	xmlns:content = 'http://purl.org/rss/1.0/modules/content/'
	xmlns:xhtml='http://www.w3.org/1999/xhtml'
	xmlns:slash='http://purl.org/rss/1.0/modules/slash/'
	xmlns:dc='http://purl.org/dc/elements/1.1/' 
	exclude-result-prefixes='content slash dc'>
	
<xsl:param name="FeedUrl"/>
<xsl:param name="FeedName"/>
<xsl:param name="ImageUrl"/>
<xsl:param name="ItemUrl"/>
<xsl:param name="CommentUrl"/>
<xsl:param name="CommentCount"/>

	<!--<xsl:output method='xml' indent='yes' /> -->

	<xsl:template match="/">
		<xsl:apply-templates select="//item">
		</xsl:apply-templates>
	</xsl:template>
	
	<xsl:template match="item">
	<![CDATA[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >]]>
		<html>
			<head>
				<title><xsl:value-of disable-output-escaping='yes' select="title"/></title>
				<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
				<base href="{$FeedUrl}"/>
<![CDATA[
<style type="text/css">
body 
{
	margin:0; 
	padding:0; 
	background:#ffffff; 
	color:#000000
}
A {color:#66c; text-decoration: none;}
A.black {color:#000; text-decoration: none;}
A:hover, A:active {text-decoration: underline;}
</style>
]]>		
			</head>
			<body>
				<table width="100%" border="0" cellpadding="0" cellspacing="0" style="font-size: 11pt; font-family: Times New Roman">
					<tr bgcolor="#EFEFEF" valign="top">
						<td align="left">
							<xsl:if test="$ImageUrl != ''">
								<a href="{$FeedUrl}" alt="{$FeedName}">
									<image align="left" border="0" src="{$ImageUrl}"></image>
								</a>
							</xsl:if>
							<xsl:choose>
								<xsl:when test="source"><b style="padding-left: 5px">Feed:</b>&#32;<a><xsl:attribute name="href"><xsl:value-of select="source/@url"></xsl:value-of></xsl:attribute><xsl:value-of disable-output-escaping='yes' select="source"/></a></xsl:when>
								<xsl:otherwise>&#32;<b style="padding-left: 5px">Feed:</b>&#32;<a href="{$FeedUrl}"><xsl:value-of disable-output-escaping='yes' select="$FeedName"/></a></xsl:otherwise>
							</xsl:choose>
							<br/>&#32;<b style="padding-left: 5px">Title:</b><a href="{link}" style="padding-left: 5px"><xsl:value-of disable-output-escaping='yes' select="title"/></a>
						</td>
						<td align="right" style="padding-right: 5px">
							<xsl:if test="creator != ''"><b>Author:</b>&#32;<xsl:value-of disable-output-escaping='yes' select="creator"/></xsl:if>
						</td>
					</tr>
					<tr bgcolor="#666666" height="1"><td colspan="2"></td></tr>
				</table>
				<div style="background-color: #808080; padding: 0.075in; height: 100%">
					<div style="padding: .15in; width: 99.5%; height: 100%; background-color: white; border: 1px solid black; FILTER: progid:DXImageTransform.Microsoft.dropShadow( Color=000000,offX=2,offY=2,positive=true);">
						<xsl:apply-templates select="description"/>
						<div style="padding: 0.15in; font-weight: bold; FILTER: none;">
							<a href="{link}">Original Post</a><span style="width: 0.25in">&#32;</span>
							<xsl:if test="$CommentCount != '0'">
								<a href="{$CommentUrl}">Comments (<xsl:value-of disable-output-escaping='yes' select="$CommentCount"/>)</a>
							</xsl:if>
						</div>
					</div>
				</div>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="description">
		<div style="background: white; FILTER: none;">
			<xsl:apply-templates select="@* | * | cdata | comment() | processing-instruction() | text()" />
		</div>
	</xsl:template>

	<xsl:template match="@*|*|cdata|comment()|processing-instruction()|text()">
		<xsl:copy>
			<xsl:apply-templates select="@* | * | cdata | comment() | processing-instruction() | text()" />
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
